# Copyright 2004 SunCERT, Sun Microsystems Inc
# Released under the terms of the GNU General Public License, version 2.
# Written by Ruediger Riediger <ruediger.riediger@sun.com>
#
# MANIFEST: HTML-mail Overlay, allow text/html for transaction content
#
# $Id: RT::Transaction_Local.pm,v 1.0 2005/03/21 zardoz Exp $

no warnings qw(redefine);

sub ContentObj {

    my $self = shift;

    # If we don\'t have any content, return undef now.
    unless ( $self->Attachments->First ) {
        return (undef);
    }

    # Get the set of toplevel attachments to this transaction.
    my $Attachment = $self->Attachments->First();

    # If it's a message or a plain part, just return the
    # body.
    if ( $Attachment->ContentType() =~ '^(text/plain$|message/)' ) {
        return ($Attachment);
    }

    # If it's a multipart object, first try returning the first
    # text/plain part.

    elsif ( $Attachment->ContentType() =~ '^multipart/' ) {
        my $plain_parts = $Attachment->Children();
        $plain_parts->ContentType( VALUE => 'text/plain' );

        # If we actully found a part, return its content
        if ( $plain_parts->First && $plain_parts->First->Content ne '' ) {
            return ( $plain_parts->First );
        }

        # If that fails, return the  first text/plain or message/ part
        # which has some content.

        else {
            my $all_parts = $Attachment->Children();
            while ( my $part = $all_parts->Next ) {
                if (( $part->ContentType() =~ '^(text/plain$|message/)' ) &&  $part->Content()  ) {
                    return ($part);
                }
            }
	    ### \/ SunCERT: HTML-mail Overlay \/ ###
	    # still here? last resort, try again to find any HTML content
            $all_parts = $Attachment->Children();
            while ( my $part = $all_parts->Next ) {
                if (( $part->ContentType() eq 'text/html' ) &&  $part->Content()  ) {
                    return ($part);
                }
            }
	    ### /\ SunCERT: HTML-mail Overlay /\ ###
        }

    }
    ### \/ SunCERT: HTML-mail Overlay \/ ###
    elsif ( $Attachment->ContentType() eq 'text/html' ) {
	# last resort - if nothing else is here, return HTML
        return ($Attachment);
    }
    ### /\ SunCERT: HTML-mail Overlay /\ ###

    # We found no content. suck
    return (undef);
}

1;

